using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Contract;
namespace CMSMicroservice.Protobuf.Validator.Contract;

public class DeleteContractRequestValidator : AbstractValidator<DeleteContractRequest>
{
    public DeleteContractRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeleteContractRequest>.CreateWithOptions((DeleteContractRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
